# Nano Banana 2.1 API

> Teksta pārvēršana attēlā ar 1K/2K/4K izvadi, ļoti platām malu attiecībām, tīmekļa meklēšanu un domāšanas līmeņiem

Ģenerē attēlus no līdz 50000 rakstzīmēm gara `prompt`. `resolution` ir 1K, 2K vai 4K, bet `aspect_ratio` ietver auto un ekstrēmas attiecības, piemēram, 8:1 un 1:8. Pievienoti `enable_web_search`, `system_prompt` un `thinking_level` ar vērtībām minimal, medium vai high. Vienā pieprasījumā var ģenerēt līdz 4 attēliem.

- Model id: `google/nano-banana-2.1`
- Made by: Google
- Category: Text to Image
- Output: image
- Estimated price per run: from $0.082 / image (cheapest run $0.082 (82 API credits))
- Run: `POST https://api.doitong.ru/v1/run/google/nano-banana-2.1`
- Quote: `POST https://api.doitong.ru/v1/quote/google/nano-banana-2.1`
- Docs page: https://doitong.com/lv/developers/models/google/nano-banana-2.1

## Pricing

Price: **from $0.082 / image** (the lowest tier; the quote prices your exact input). Estimated from the typical cost of one run, per output (`num_images`). The quote is exactly what the run charges.

Price rules (the first rule that matches the input wins; a parameter you leave out counts as its default):

- When `resolution` = 4K: base price × 7.92
- When `resolution` = 2K: base price × 4

The full example input below costs $0.082 = 82 API credits (1 image × 82 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/google/nano-banana-2.1` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | 3 – 50000 characters | Teksta norādes attēla ģenerēšanai. |
| `num_images` | `num_outputs` | integer | no | `1` | 1 – 4 | Ģenerēšanai pieprasītais attēlu skaits. |
| `seed` |  | integer \| null | no |  |  | Sākumvērtība, kas inicializē nejaušo skaitļu ģenerēšanu. |
| `aspect_ratio` |  | enum (string) \| null | no | `auto` | `auto`, `21:9`, `16:9`, `3:2`, `4:3`, `5:4`, `1:1`, `4:5`, `3:4`, `2:3`, `9:16`, `4:1`, `1:4`, `8:1`, `1:8` | Tieši izvēlieties ģenerētā attēla malu attiecību, tostarp galējās opcijas 4:1, 1:4, 8:1, 1:8, vai izvēlieties "auto", lai modelis to noteiktu pēc uzvednes. |
| `output_format` |  | enum (string) | no | `png` | `jpeg`, `png`, `webp` | Iegūtā attēla faila formāts. |
| `safety_tolerance` |  | enum (string) | no | `4` | `1`, `2`, `3`, `4`, `5`, `6` | Iestatiet satura moderēšanas toleranci no vismazāk ierobežojošā līmeņa 6 līdz stingrākajam līmenim 1, kas bloķē lielāko daļu satura. |
| `system_prompt` |  | string | no | `` | ≤ 50000 characters | Neobligātas visam pieprasījumam piemērojamas personības un izvades stila norādes, kas Gemini tiek nodotas kā sistēmas instrukcija vai ar OpenAI saderīgiem nodrošinātājiem kā sistēmas ziņojums. Ja vērtība ir tukša, šai instrukcijai nekas netiek nosūtīts. |
| `resolution` |  | enum (string) | no | `1K` | `1K`, `2K`, `4K` | Izvades attēla izšķirtspēja. |
| `limit_generations` |  | boolean | no | `true` |  | Eksperimentāls ģenerēšanas ierobežojums, kas aktivizēts var ietekmēt kvalitāti. Ar `True` katra uzvednes kārta tiek ierobežota līdz 1 ģenerēšanai, ignorējot attēlu skaita norādes uzvednē un modeļa ģenerētos starpattēlus. |
| `enable_web_search` |  | boolean | no | `false` |  | Tīmekļa meklēšanas pārslēgs attēla ģenerēšanai, kas ļauj modelim attēlā iekļaut aktuālu tiešsaistē atrastu informāciju. |
| `thinking_level` |  | enum (string) \| null | no | `medium` | `minimal`, `medium`, `high` | Spriešanas līmenis pirms ģenerēšanas: augstāki iestatījumi patērē vairāk domāšanas marķieru, bet var nodrošināt labākas sarežģītas kompozīcijas. |

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/google/nano-banana-2.1?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/google/nano-banana-2.1?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/google/nano-banana-2.1", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "google/nano-banana-2.1",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "google/nano-banana-2.1",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 82,
    "usd": "0.082",
    "charged": 82,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field"
  },
  "output": {
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "description": "string"
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Modeļa ģenerētie attēli. |
| `description` | string | Ģenerētajiem attēliem pievienotais apraksts. |

## Related models

- [Nano Banana 2](https://doitong.com/developers/models/nano-banana-2.md) (`nano-banana-2`): from $0.06 / image
- [Nano Banana Pro](https://doitong.com/developers/models/nano-banana-pro.md) (`nano-banana-pro`): from $0.15 / image
- [FLUX.1 \[dev\]](https://doitong.com/developers/models/flux/dev.md) (`flux/dev`): $0.025 / megapixel
- [FLUX.1 \[schnell\]](https://doitong.com/developers/models/flux/schnell.md) (`flux/schnell`): $0.003 / megapixel
- [FLUX.2 \[dev\]](https://doitong.com/developers/models/flux-2.md) (`flux-2`): $0.012 / megapixel
- [FLUX.2 \[pro\]](https://doitong.com/developers/models/flux-2-pro.md) (`flux-2-pro`): $0.015 / megapixel of output image
- [GPT Image 2.5 Text to Image](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/text-to-image.md) (`openai/gpt-image-2.5/flare/text-to-image`): from $0.008 / image
- [Ideogram V4.5](https://doitong.com/developers/models/ideogram/v4.5.md) (`ideogram/v4.5`): from $0.03 / image

## Links

- HTML page: https://doitong.com/developers/models/google/nano-banana-2.1
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=google/nano-banana-2.1
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/google/nano-banana-2.1
